"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _BaseState2 = _interopRequireDefault(require("./BaseState"));

var _Serializable = require("./Serializable");

var _common = _interopRequireDefault(require("./common"));

var _utils = _interopRequireWildcard(require("./utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _slicedToArray(arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return _sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Account =
/*#__PURE__*/
function (_BaseState) {
  _inherits(Account, _BaseState);

  function Account(_ref) {
    var _this;

    var version = _ref.version,
        hash = _ref.hash,
        isFrozen = _ref.isFrozen,
        votes = _ref.votes,
        balances = _ref.balances;

    _classCallCheck(this, Account);

    _this = _possibleConstructorReturn(this, (Account.__proto__ || Object.getPrototypeOf(Account)).call(this, {
      version: version
    }));
    Object.defineProperty(_this, "hash", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "hashHex", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "isFrozen", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "votes", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "balances", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "equals", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.equals(Account, function (other) {
        return _common.default.uInt160Equal(_this.hash, other.hash);
      })
    });
    Object.defineProperty(_this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _Serializable.createSerializeWire)(_this.serializeWireBase.bind(_this))
    });
    _this.hash = hash;
    _this.hashHex = _common.default.uInt160ToHex(hash);
    _this.isFrozen = isFrozen || false;
    _this.votes = votes || [];
    _this.balances = balances || {};
    return _this;
  }

  _createClass(Account, [{
    key: "isDeletable",
    value: function isDeletable() {
      var balances = _utils.default.values(this.balances);

      return !this.isFrozen && this.votes.length === 0 && (balances.length === 0 || balances.every(function (value) {
        return value.lte(_utils.default.ZERO);
      }));
    }
  }, {
    key: "update",
    value: function update(_ref2) {
      var isFrozen = _ref2.isFrozen,
          votes = _ref2.votes,
          balances = _ref2.balances;
      return new Account({
        hash: this.hash,
        isFrozen: isFrozen == null ? this.isFrozen : isFrozen,
        votes: votes == null ? this.votes : votes,
        balances: balances == null ? this.balances : balances
      });
    }
  }, {
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      writer.writeUInt8(this.version);
      writer.writeUInt160(this.hash);
      writer.writeBoolean(this.isFrozen);
      writer.writeArray(this.votes, function (vote) {
        writer.writeECPoint(vote);
      });

      var balances = _lodash.default.pickBy(this.balances, function (value) {
        return value.gt(_utils.default.ZERO);
      });

      writer.writeObject(balances, function (key, value) {
        writer.writeUInt256(key);
        writer.writeFixed8(value);
      });
    }
  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        version: this.version,
        script_hash: _utils.JSONHelper.writeUInt160(this.hash),
        frozen: this.isFrozen,
        votes: this.votes.map(function (vote) {
          return _utils.JSONHelper.writeECPoint(vote);
        }),
        balances: _utils.default.entries(this.balances).map(function (_ref3) {
          var _ref4 = _slicedToArray(_ref3, 2),
              asset = _ref4[0],
              value = _ref4[1];

          return {
            asset: _utils.JSONHelper.writeUInt256(asset),
            value: _utils.JSONHelper.writeFixed8(value)
          };
        })
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(_ref5) {
      var reader = _ref5.reader;
      var version = reader.readUInt8();
      var hash = reader.readUInt160();
      var isFrozen = reader.readBoolean();
      var votes = reader.readArray(function () {
        return reader.readECPoint();
      });
      var balances = reader.readObject(function () {
        var key = _common.default.uInt256ToHex(reader.readUInt256());

        var value = reader.readFixed8();
        return {
          key: key,
          value: value
        };
      });
      return new this({
        version: version,
        hash: hash,
        isFrozen: isFrozen,
        votes: votes,
        balances: balances
      });
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return Account;
}(_BaseState2.default);

exports.default = Account;