"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toJSONAssetType = exports.assertAssetType = exports.InvalidAssetTypeError = exports.hasFlag = exports.ASSET_TYPE = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ASSET_TYPE = {
  CREDIT_FLAG: 0x40,
  DUTY_FLAG: 0x80,
  GOVERNING_TOKEN: 0x00,
  UTILITY_TOKEN: 0x01,
  CURRENCY: 0x08,
  SHARE: 0x90,
  INVOICE: 0x98,
  TOKEN: 0x60
};
exports.ASSET_TYPE = ASSET_TYPE;

var hasFlag = function hasFlag(assetType, flag // eslint-disable-next-line
) {
  return (assetType & flag) === flag;
};

exports.hasFlag = hasFlag;

var InvalidAssetTypeError =
/*#__PURE__*/
function (_Error) {
  _inherits(InvalidAssetTypeError, _Error);

  function InvalidAssetTypeError(assetType) {
    var _this;

    _classCallCheck(this, InvalidAssetTypeError);

    _this = _possibleConstructorReturn(this, (InvalidAssetTypeError.__proto__ || Object.getPrototypeOf(InvalidAssetTypeError)).call(this, "Expected asset type, found: ".concat(assetType.toString(16))));
    Object.defineProperty(_this, "assetType", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.assetType = assetType;
    return _this;
  }

  return InvalidAssetTypeError;
}(Error);

exports.InvalidAssetTypeError = InvalidAssetTypeError;

var assertAssetType = function assertAssetType(assetType) {
  switch (assetType) {
    case ASSET_TYPE.CREDIT_FLAG:
      return ASSET_TYPE.CREDIT_FLAG;

    case ASSET_TYPE.DUTY_FLAG:
      return ASSET_TYPE.DUTY_FLAG;

    case ASSET_TYPE.GOVERNING_TOKEN:
      return ASSET_TYPE.GOVERNING_TOKEN;

    case ASSET_TYPE.UTILITY_TOKEN:
      return ASSET_TYPE.UTILITY_TOKEN;

    case ASSET_TYPE.CURRENCY:
      return ASSET_TYPE.CURRENCY;

    case ASSET_TYPE.SHARE:
      return ASSET_TYPE.SHARE;

    case ASSET_TYPE.INVOICE:
      return ASSET_TYPE.INVOICE;

    case ASSET_TYPE.TOKEN:
      return ASSET_TYPE.TOKEN;

    default:
      throw new InvalidAssetTypeError(assetType);
  }
};

exports.assertAssetType = assertAssetType;

var toJSONAssetType = function toJSONAssetType(type) {
  switch (type) {
    case 0x40:
      return 'CreditFlag';

    case 0x80:
      return 'DutyFlag';

    case 0x00:
      return 'GoverningToken';

    case 0x01:
      return 'UtilityToken';

    case 0x08:
      return 'Currency';

    case 0x90:
      return 'Share';

    case 0x98:
      return 'Invoice';

    case 0x60:
      return 'Token';

    default:
      // eslint-disable-next-line
      type;
      throw new InvalidAssetTypeError(type);
  }
};

exports.toJSONAssetType = toJSONAssetType;