"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.serializeContractWireBase = exports.deserializeContractWireBase = exports.sizeOfContract = exports.default = void 0;

var _BaseState2 = _interopRequireDefault(require("./BaseState"));

var _contractParameter = require("./contractParameter");

var _Serializable = require("./Serializable");

var _common = _interopRequireDefault(require("./common"));

var _crypto = _interopRequireDefault(require("./crypto"));

var _utils = _interopRequireWildcard(require("./utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Contract =
/*#__PURE__*/
function (_BaseState) {
  _inherits(Contract, _BaseState);

  function Contract(_ref) {
    var _this;

    var version = _ref.version,
        script = _ref.script,
        parameterList = _ref.parameterList,
        returnType = _ref.returnType,
        hasStorage = _ref.hasStorage,
        name = _ref.name,
        codeVersion = _ref.codeVersion,
        author = _ref.author,
        email = _ref.email,
        description = _ref.description;

    _classCallCheck(this, Contract);

    _this = _possibleConstructorReturn(this, (Contract.__proto__ || Object.getPrototypeOf(Contract)).call(this, {
      version: version
    }));
    Object.defineProperty(_this, "script", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "parameterList", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "returnType", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "hasStorage", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "name", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "codeVersion", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "author", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "email", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "description", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "__contractSize", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.lazy(function () {
        return sizeOfContract({
          script: _this.script,
          parameterList: _this.parameterList,
          name: _this.name,
          codeVersion: _this.codeVersion,
          author: _this.author,
          email: _this.email,
          description: _this.description
        });
      })
    });
    Object.defineProperty(_this, "_hash", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.lazy(function () {
        return _crypto.default.toScriptHash(_this.script);
      })
    });
    Object.defineProperty(_this, "_hashHex", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.lazy(function () {
        return _common.default.uInt160ToHex(_this.hash);
      })
    });
    Object.defineProperty(_this, "equals", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.equals(Contract, function (other) {
        return _common.default.uInt160Equal(_this.hash, other.hash);
      })
    });
    Object.defineProperty(_this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _Serializable.createSerializeWire)(_this.serializeWireBase.bind(_this))
    });
    _this.script = script;
    _this.parameterList = parameterList;
    _this.returnType = returnType;
    _this.hasStorage = hasStorage;
    _this.name = name;
    _this.codeVersion = codeVersion;
    _this.author = author;
    _this.email = email;
    _this.description = description;
    return _this;
  } // eslint-disable-next-line


  _createClass(Contract, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      // eslint-disable-next-line
      serializeContractWireBase({
        writer: writer,
        contract: this
      });
    }
  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        version: this.version,
        code: {
          hash: _utils.JSONHelper.writeUInt160(this.hash),
          script: _utils.JSONHelper.writeBuffer(this.script),
          parameters: this.parameterList.map(function (parameter) {
            return (0, _contractParameter.toJSONContractParameterType)(parameter);
          }),
          returntype: (0, _contractParameter.toJSONContractParameterType)(this.returnType)
        },
        needstorage: this.hasStorage,
        name: this.name,
        code_version: this.codeVersion,
        author: this.author,
        email: this.email,
        description: this.description
      };
    }
  }, {
    key: "size",
    get: function get() {
      return this.__contractSize();
    }
  }, {
    key: "hash",
    get: function get() {
      return this._hash();
    }
  }, {
    key: "hashHex",
    get: function get() {
      return this._hashHex();
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      // eslint-disable-next-line
      return deserializeContractWireBase({
        context: options.context,
        reader: options.reader
      });
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return Contract;
}(_BaseState2.default);

exports.default = Contract;

var sizeOfContract = function sizeOfContract(_ref2) {
  var script = _ref2.script,
      parameterList = _ref2.parameterList,
      name = _ref2.name,
      codeVersion = _ref2.codeVersion,
      author = _ref2.author,
      email = _ref2.email,
      description = _ref2.description,
      publishVersion = _ref2.publishVersion;
  return _utils.IOHelper.sizeOfVarBytesLE(script) + _utils.IOHelper.sizeOfVarBytesLE(Buffer.from(parameterList)) + _utils.IOHelper.sizeOfUInt8 + ( // TODO: Doesn't take version into account?
  publishVersion == null ? _utils.IOHelper.sizeOfBoolean : 0) + _utils.IOHelper.sizeOfVarString(name) + _utils.IOHelper.sizeOfVarString(codeVersion) + _utils.IOHelper.sizeOfVarString(author) + _utils.IOHelper.sizeOfVarString(email) + _utils.IOHelper.sizeOfVarString(description);
};

exports.sizeOfContract = sizeOfContract;

var deserializeContractWireBase = function deserializeContractWireBase(_ref3) {
  var reader = _ref3.reader,
      publishVersion = _ref3.publishVersion;
  var script = reader.readVarBytesLE();
  var parameterList = [].concat(_toConsumableArray(reader.readVarBytesLE())).map(function (value) {
    return (0, _contractParameter.assertContractParameterType)(value);
  });
  var returnType = (0, _contractParameter.assertContractParameterType)(reader.readUInt8());
  var hasStorage = publishVersion == null || publishVersion >= 1 ? reader.readBoolean() : false;
  var name = reader.readVarString(252);
  var codeVersion = reader.readVarString(252);
  var author = reader.readVarString(252);
  var email = reader.readVarString(252);
  var description = reader.readVarString(65536);
  return new Contract({
    script: script,
    parameterList: parameterList,
    returnType: returnType,
    hasStorage: hasStorage,
    name: name,
    codeVersion: codeVersion,
    author: author,
    email: email,
    description: description
  });
};

exports.deserializeContractWireBase = deserializeContractWireBase;

var serializeContractWireBase = function serializeContractWireBase(_ref4) {
  var writer = _ref4.writer,
      contract = _ref4.contract,
      publishVersion = _ref4.publishVersion;
  writer.writeVarBytesLE(contract.script);
  writer.writeVarBytesLE(Buffer.from(contract.parameterList));
  writer.writeUInt8(contract.returnType);

  if (publishVersion == null || publishVersion >= 1) {
    writer.writeBoolean(contract.hasStorage);
  }

  writer.writeVarString(contract.name);
  writer.writeVarString(contract.codeVersion);
  writer.writeVarString(contract.author);
  writer.writeVarString(contract.email);
  writer.writeVarString(contract.description);
};

exports.serializeContractWireBase = serializeContractWireBase;