"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _BlockBase2 = _interopRequireDefault(require("./BlockBase"));

var _errors = require("./errors");

var _utils = _interopRequireWildcard(require("./utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

var Header =
/*#__PURE__*/
function (_BlockBase) {
  _inherits(Header, _BlockBase);

  function Header(add) {
    var _this;

    _classCallCheck(this, Header);

    _this = _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).call(this, add));
    Object.defineProperty(_this, "__headerSize", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.__headerSize = _utils.default.lazy(function () {
      return _get(Header.prototype.__proto__ || Object.getPrototypeOf(Header.prototype), "size", _this) + _utils.IOHelper.sizeOfUInt8;
    });
    return _this;
  }

  _createClass(Header, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      _get(Header.prototype.__proto__ || Object.getPrototypeOf(Header.prototype), "serializeWireBase", this).call(this, writer);

      writer.writeUInt8(0);
    }
  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(context) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", _get(Header.prototype.__proto__ || Object.getPrototypeOf(Header.prototype), "serializeBlockBaseJSON", this).call(this, context));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function serializeJSON(_x) {
        return _ref.apply(this, arguments);
      }

      return serializeJSON;
    }()
  }, {
    key: "size",
    get: function get() {
      return this.__headerSize();
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var reader = options.reader;

      var blockBase = _get(Header.__proto__ || Object.getPrototypeOf(Header), "deserializeBlockBaseWireBase", this).call(this, options);

      if (reader.readUInt8() !== 0) {
        throw new _errors.InvalidFormatError();
      }

      return new this({
        version: blockBase.version,
        previousHash: blockBase.previousHash,
        merkleRoot: blockBase.merkleRoot,
        timestamp: blockBase.timestamp,
        index: blockBase.index,
        consensusData: blockBase.consensusData,
        nextConsensus: blockBase.nextConsensus,
        script: blockBase.script
      });
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return Header;
}(_BlockBase2.default);

exports.default = Header;