"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("./utils");

var _Serializable = require("./Serializable");

var _invocationResult = require("./invocationResult");

var _common = _interopRequireDefault(require("./common"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var InvocationData =
/*#__PURE__*/
function () {
  function InvocationData(_ref) {
    var hash = _ref.hash,
        assetHash = _ref.assetHash,
        contractHashes = _ref.contractHashes,
        blockIndex = _ref.blockIndex,
        transactionIndex = _ref.transactionIndex,
        result = _ref.result;

    _classCallCheck(this, InvocationData);

    Object.defineProperty(this, "hash", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "assetHash", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "contractHashes", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "blockIndex", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "transactionIndex", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "result", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this))
    });
    this.hash = hash;
    this.assetHash = assetHash;
    this.contractHashes = contractHashes;
    this.blockIndex = blockIndex;
    this.transactionIndex = transactionIndex;
    this.result = result;
  }

  _createClass(InvocationData, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      writer.writeUInt256(this.hash);
      writer.writeUInt256(this.assetHash || _common.default.ZERO_UINT256);
      writer.writeArray(this.contractHashes, function (contractHash) {
        writer.writeUInt160(contractHash);
      });
      writer.writeUInt32LE(this.blockIndex);
      writer.writeUInt32LE(this.transactionIndex);
      this.result.serializeWireBase(writer);
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var reader = options.reader;
      var hash = reader.readUInt256();
      var assetHash = reader.readUInt256();
      var contractHashes = reader.readArray(function () {
        return reader.readUInt160();
      });
      var blockIndex = reader.readUInt32LE();
      var transactionIndex = reader.readUInt32LE();
      var result = (0, _invocationResult.deserializeWireBase)(options);
      return new this({
        hash: hash,
        assetHash: _common.default.uInt256Equal(assetHash, _common.default.ZERO_UINT256) ? undefined : assetHash,
        contractHashes: contractHashes,
        blockIndex: blockIndex,
        transactionIndex: transactionIndex,
        result: result
      });
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return InvocationData;
}();

exports.default = InvocationData;