"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertScriptContainerType = exports.InvalidScriptContainerTypeError = exports.SCRIPT_CONTAINER_TYPE = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCRIPT_CONTAINER_TYPE = {
  TRANSACTION: 0x00,
  BLOCK: 0x01
};
exports.SCRIPT_CONTAINER_TYPE = SCRIPT_CONTAINER_TYPE;

var InvalidScriptContainerTypeError =
/*#__PURE__*/
function (_Error) {
  _inherits(InvalidScriptContainerTypeError, _Error);

  function InvalidScriptContainerTypeError(value) {
    var _this;

    _classCallCheck(this, InvalidScriptContainerTypeError);

    _this = _possibleConstructorReturn(this, (InvalidScriptContainerTypeError.__proto__ || Object.getPrototypeOf(InvalidScriptContainerTypeError)).call(this, "Expected script container type, found: ".concat(value.toString(16))));
    Object.defineProperty(_this, "value", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.value = value;
    return _this;
  }

  return InvalidScriptContainerTypeError;
}(Error);

exports.InvalidScriptContainerTypeError = InvalidScriptContainerTypeError;

var assertScriptContainerType = function assertScriptContainerType(value) {
  switch (value) {
    case 0x00:
      return SCRIPT_CONTAINER_TYPE.TRANSACTION;

    case 0x01:
      return SCRIPT_CONTAINER_TYPE.BLOCK;

    default:
      throw new InvalidScriptContainerTypeError(value);
  }
};

exports.assertScriptContainerType = assertScriptContainerType;