"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDeserializeWire = createDeserializeWire;
exports.createSerializeWire = void 0;

var _utils = require("./utils");

var createSerializeWire = function createSerializeWire(serializeWireBase) {
  return function () {
    var writer = new _utils.BinaryWriter();
    serializeWireBase(writer);
    return writer.toBuffer();
  };
};

exports.createSerializeWire = createSerializeWire;

function createDeserializeWire(deserializeWireBase) {
  return function (options) {
    return deserializeWireBase({
      context: options.context,
      reader: new _utils.BinaryReader(options.buffer)
    });
  };
}