"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Serializable = require("./Serializable");

var _common = _interopRequireDefault(require("./common"));

var _utils = _interopRequireWildcard(require("./utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var StorageItem =
/*#__PURE__*/
function () {
  function StorageItem(_ref) {
    var _this = this;

    var hash = _ref.hash,
        key = _ref.key,
        value = _ref.value;

    _classCallCheck(this, StorageItem);

    Object.defineProperty(this, "hash", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "key", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "value", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "equals", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.equals(StorageItem, function (other) {
        return _common.default.uInt160Equal(_this.hash, other.hash) && _this.key.equals(other.key) && _this.value.equals(other.value);
      })
    });
    Object.defineProperty(this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this))
    });
    this.hash = hash;
    this.key = key;
    this.value = value;
  }

  _createClass(StorageItem, [{
    key: "update",
    value: function update(_ref2) {
      var value = _ref2.value;
      return new this.constructor({
        hash: this.hash,
        key: this.key,
        value: value
      });
    }
  }, {
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      writer.writeUInt160(this.hash);
      writer.writeVarBytesLE(this.key);
      writer.writeVarBytesLE(this.value);
    }
  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        hash: _utils.JSONHelper.writeUInt160(this.hash),
        key: _utils.JSONHelper.writeBuffer(this.key),
        value: _utils.JSONHelper.writeBuffer(this.value)
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(_ref3) {
      var reader = _ref3.reader;
      var hash = reader.readUInt160();
      var key = reader.readVarBytesLE();
      var value = reader.readVarBytesLE();
      return new this({
        hash: hash,
        key: key,
        value: value
      });
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return StorageItem;
}();

exports.default = StorageItem;