"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Serializable = require("./Serializable");

var _utils = _interopRequireWildcard(require("./utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Witness =
/*#__PURE__*/
function () {
  function Witness(_ref) {
    var _this = this;

    var invocation = _ref.invocation,
        verification = _ref.verification;

    _classCallCheck(this, Witness);

    Object.defineProperty(this, "verification", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "invocation", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "__size", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.lazy(function () {
        return _utils.IOHelper.sizeOfVarBytesLE(_this.invocation) + _utils.IOHelper.sizeOfVarBytesLE(_this.verification);
      })
    });
    Object.defineProperty(this, "equals", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.equals(Witness, function (other) {
        return _this.invocation.equals(other.invocation) && _this.verification.equals(other.verification);
      })
    });
    Object.defineProperty(this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this))
    });
    this.invocation = invocation;
    this.verification = verification;
  }

  _createClass(Witness, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      writer.writeVarBytesLE(this.invocation);
      writer.writeVarBytesLE(this.verification);
    }
  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        invocation: _utils.JSONHelper.writeBuffer(this.invocation),
        verification: _utils.JSONHelper.writeBuffer(this.verification)
      };
    }
  }, {
    key: "size",
    get: function get() {
      return this.__size();
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(_ref2) {
      var reader = _ref2.reader;
      var invocation = reader.readVarBytesLE(_utils.default.USHORT_MAX_NUMBER_PLUS_ONE);
      var verification = reader.readVarBytesLE(_utils.default.USHORT_MAX_NUMBER_PLUS_ONE);
      return new this({
        invocation: invocation,
        verification: verification
      });
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return Witness;
}();

exports.default = Witness;