"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deserializeWire = exports.deserializeWireBase = void 0;

var _ActionType = require("./ActionType");

var _Serializable = require("../Serializable");

var _LogAction = _interopRequireDefault(require("./LogAction"));

var _NotificationAction = _interopRequireDefault(require("./NotificationAction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var deserializeWireBase = function deserializeWireBase(options) {
  var reader = options.reader;
  var type = (0, _ActionType.assertActionType)(reader.clone().readUInt8());

  switch (type) {
    case 0x00:
      return _LogAction.default.deserializeWireBase(options);

    case 0x01:
      return _NotificationAction.default.deserializeWireBase(options);

    default:
      // eslint-disable-next-line
      type;
      throw new _ActionType.InvalidActionTypeError(type);
  }
};

exports.deserializeWireBase = deserializeWireBase;
var deserializeWire = (0, _Serializable.createDeserializeWire)(deserializeWireBase);
exports.deserializeWire = deserializeWire;