"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("../utils");

var _Serializable = require("../Serializable");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var ActionBase =
/*#__PURE__*/
function () {
  function ActionBase(_ref) {
    var type = _ref.type,
        version = _ref.version,
        blockIndex = _ref.blockIndex,
        blockHash = _ref.blockHash,
        transactionIndex = _ref.transactionIndex,
        transactionHash = _ref.transactionHash,
        index = _ref.index,
        scriptHash = _ref.scriptHash;

    _classCallCheck(this, ActionBase);

    _initialiseProps.call(this);

    this.type = type;
    this.version = version == null ? this.constructor.VERSION : version;
    this.blockIndex = blockIndex;
    this.blockHash = blockHash;
    this.transactionIndex = transactionIndex;
    this.transactionHash = transactionHash;
    this.index = index;
    this.scriptHash = scriptHash;
  }

  _createClass(ActionBase, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      writer.writeUInt8(this.type);
      writer.writeUInt8(this.version);
      writer.writeUInt32LE(this.blockIndex);
      writer.writeUInt256(this.blockHash);
      writer.writeUInt32LE(this.transactionIndex);
      writer.writeUInt256(this.transactionHash);
      writer.writeUInt32LE(this.index);
      writer.writeUInt160(this.scriptHash);
    }
  }, {
    key: "serializeActionBaseJSON",
    // eslint-disable-next-line
    value: function serializeActionBaseJSON(context) {
      return {
        version: this.version,
        blockIndex: this.blockIndex,
        blockHash: _utils.JSONHelper.writeUInt256(this.blockHash),
        transactionIndex: this.transactionIndex,
        transactionHash: _utils.JSONHelper.writeUInt256(this.transactionHash),
        index: this.index,
        scriptHash: _utils.JSONHelper.writeUInt160(this.scriptHash)
      };
    }
  }], [{
    key: "deserializeWireBase",
    // eslint-disable-next-line
    value: function deserializeWireBase(options) {
      throw new Error('Not Implemented');
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return ActionBase;
}();

exports.default = ActionBase;
Object.defineProperty(ActionBase, "VERSION", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: 0
});
Object.defineProperty(ActionBase, "deserializeActionBaseWireBase", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: function value(_ref2) {
    var reader = _ref2.reader;
    var type = reader.readUInt8();
    var version = reader.readUInt8();
    var blockIndex = reader.readUInt32LE();
    var blockHash = reader.readUInt256();
    var transactionIndex = reader.readUInt32LE();
    var transactionHash = reader.readUInt256();
    var index = reader.readUInt32LE();
    var scriptHash = reader.readUInt160();
    return {
      type: type,
      version: version,
      blockIndex: blockIndex,
      blockHash: blockHash,
      transactionIndex: transactionIndex,
      transactionHash: transactionHash,
      index: index,
      scriptHash: scriptHash
    };
  }
});

var _initialiseProps = function _initialiseProps() {
  Object.defineProperty(this, "type", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: void 0
  });
  Object.defineProperty(this, "version", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: void 0
  });
  Object.defineProperty(this, "blockIndex", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: void 0
  });
  Object.defineProperty(this, "blockHash", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: void 0
  });
  Object.defineProperty(this, "transactionIndex", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: void 0
  });
  Object.defineProperty(this, "transactionHash", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: void 0
  });
  Object.defineProperty(this, "index", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: void 0
  });
  Object.defineProperty(this, "scriptHash", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: void 0
  });
  Object.defineProperty(this, "serializeWire", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this))
  });
};