"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertActionType = exports.InvalidActionTypeError = exports.ACTION_TYPE = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ACTION_TYPE = {
  LOG: 0x00,
  NOTIFICATION: 0x01
};
exports.ACTION_TYPE = ACTION_TYPE;

var InvalidActionTypeError =
/*#__PURE__*/
function (_Error) {
  _inherits(InvalidActionTypeError, _Error);

  function InvalidActionTypeError(type) {
    var _this;

    _classCallCheck(this, InvalidActionTypeError);

    _this = _possibleConstructorReturn(this, (InvalidActionTypeError.__proto__ || Object.getPrototypeOf(InvalidActionTypeError)).call(this, "Expected action type, found: ".concat(type)));
    Object.defineProperty(_this, "type", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.type = type;
    return _this;
  }

  return InvalidActionTypeError;
}(Error);

exports.InvalidActionTypeError = InvalidActionTypeError;

var assertActionType = function assertActionType(value) {
  switch (value) {
    case ACTION_TYPE.LOG:
      return ACTION_TYPE.LOG;

    case ACTION_TYPE.NOTIFICATION:
      return ACTION_TYPE.NOTIFICATION;

    default:
      throw new InvalidActionTypeError(value);
  }
};

exports.assertActionType = assertActionType;