"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ActionType = require("./ActionType");

var _ActionBase2 = _interopRequireDefault(require("./ActionBase"));

var _contractParameter = require("../contractParameter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NotificationAction =
/*#__PURE__*/
function (_ActionBase) {
  _inherits(NotificationAction, _ActionBase);

  function NotificationAction(_ref) {
    var _this;

    var version = _ref.version,
        blockIndex = _ref.blockIndex,
        blockHash = _ref.blockHash,
        transactionIndex = _ref.transactionIndex,
        transactionHash = _ref.transactionHash,
        index = _ref.index,
        scriptHash = _ref.scriptHash,
        args = _ref.args;

    _classCallCheck(this, NotificationAction);

    _this = _possibleConstructorReturn(this, (NotificationAction.__proto__ || Object.getPrototypeOf(NotificationAction)).call(this, {
      type: _ActionType.ACTION_TYPE.NOTIFICATION,
      version: version,
      blockIndex: blockIndex,
      blockHash: blockHash,
      transactionIndex: transactionIndex,
      transactionHash: transactionHash,
      index: index,
      scriptHash: scriptHash
    }));
    Object.defineProperty(_this, "args", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.args = args;
    return _this;
  }

  _createClass(NotificationAction, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      _get(NotificationAction.prototype.__proto__ || Object.getPrototypeOf(NotificationAction.prototype), "serializeWireBase", this).call(this, writer);

      writer.writeArray(this.args, function (arg) {
        return arg.serializeWireBase(writer);
      });
    }
  }, {
    key: "serializeJSON",
    value: function serializeJSON(context) {
      var action = _get(NotificationAction.prototype.__proto__ || Object.getPrototypeOf(NotificationAction.prototype), "serializeActionBaseJSON", this).call(this, context);

      return {
        type: 'Notification',
        version: action.version,
        blockIndex: action.blockIndex,
        blockHash: action.blockHash,
        transactionIndex: action.transactionIndex,
        transactionHash: action.transactionHash,
        index: action.index,
        scriptHash: action.scriptHash,
        args: this.args.map(function (arg) {
          return arg.serializeJSON(context);
        })
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var reader = options.reader;

      var action = _get(NotificationAction.__proto__ || Object.getPrototypeOf(NotificationAction), "deserializeActionBaseWireBase", this).call(this, options);

      var args = reader.readArray(function () {
        return (0, _contractParameter.deserializeWireBase)(options);
      });
      return new this({
        version: action.version,
        blockIndex: action.blockIndex,
        blockHash: action.blockHash,
        transactionIndex: action.transactionIndex,
        transactionHash: action.transactionHash,
        index: action.index,
        scriptHash: action.scriptHash,
        args: args
      });
    }
  }]);

  return NotificationAction;
}(_ActionBase2.default);

exports.default = NotificationAction;