"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _ContractParameterType = require("./ContractParameterType");

var _ContractParameterBase = _interopRequireDefault(require("./ContractParameterBase"));

var _utils = _interopRequireDefault(require("../utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IntegerContractParameter =
/*#__PURE__*/
function (_ContractParameterBas) {
  _inherits(IntegerContractParameter, _ContractParameterBas);

  function IntegerContractParameter(value) {
    var _this;

    _classCallCheck(this, IntegerContractParameter);

    _this = _possibleConstructorReturn(this, (IntegerContractParameter.__proto__ || Object.getPrototypeOf(IntegerContractParameter)).call(this));
    Object.defineProperty(_this, "type", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _ContractParameterType.CONTRACT_PARAMETER_TYPE.INTEGER
    });
    Object.defineProperty(_this, "value", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.value = value;
    return _this;
  }

  _createClass(IntegerContractParameter, [{
    key: "asBoolean",
    value: function asBoolean() {
      return !this.value.isZero();
    }
  }, {
    key: "asBuffer",
    value: function asBuffer() {
      return _utils.default.toSignedBuffer(this.value);
    }
  }, {
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      _get(IntegerContractParameter.prototype.__proto__ || Object.getPrototypeOf(IntegerContractParameter.prototype), "serializeWireBase", this).call(this, writer);

      writer.writeVarBytesLE(_utils.default.toSignedBuffer(this.value));
    }
  }, {
    key: "serializeJSON",
    value: function serializeJSON( // eslint-disable-next-line
    context) {
      return {
        type: 'Integer',
        value: this.value.toString(10)
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var reader = options.reader;

      _get(IntegerContractParameter.__proto__ || Object.getPrototypeOf(IntegerContractParameter), "deserializeContractParameterBaseWireBase", this).call(this, options);

      var value = _utils.default.fromSignedBuffer(reader.readVarBytesLE());

      return new this(value);
    }
  }]);

  return IntegerContractParameter;
}(_ContractParameterBase.default);

exports.default = IntegerContractParameter;