"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deserializeWire = exports.deserializeWireBase = void 0;

var _InvocationResultType = require("./InvocationResultType");

var _Serializable = require("../Serializable");

var _InvocationResultSuccess = _interopRequireDefault(require("./InvocationResultSuccess"));

var _InvocationResultError = _interopRequireDefault(require("./InvocationResultError"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var deserializeWireBase = function deserializeWireBase(options) {
  var reader = options.reader;
  var type = (0, _InvocationResultType.assertInvocationResultType)(reader.clone().readUInt8());

  switch (type) {
    case 0x00:
      return _InvocationResultError.default.deserializeWireBase(options);

    case 0x01:
      return _InvocationResultSuccess.default.deserializeWireBase(options);

    default:
      // eslint-disable-next-line
      type;
      throw new _InvocationResultType.InvalidInvocationResultTypeError(type);
  }
};

exports.deserializeWireBase = deserializeWireBase;
var deserializeWire = (0, _Serializable.createDeserializeWire)(deserializeWireBase);
exports.deserializeWire = deserializeWire;