"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _InvocationResultType = require("./InvocationResultType");

var _InvocationResultBase2 = _interopRequireDefault(require("./InvocationResultBase"));

var _errors = require("../errors");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MAX_SIZE = 1024;

var InvocationResultError =
/*#__PURE__*/
function (_InvocationResultBase) {
  _inherits(InvocationResultError, _InvocationResultBase);

  function InvocationResultError(_ref) {
    var _this;

    var message = _ref.message;

    _classCallCheck(this, InvocationResultError);

    _this = _possibleConstructorReturn(this, (InvocationResultError.__proto__ || Object.getPrototypeOf(InvocationResultError)).call(this));
    Object.defineProperty(_this, "type", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _InvocationResultType.INVOCATION_RESULT_TYPE.ERROR
    });
    Object.defineProperty(_this, "message", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.message = message;
    return _this;
  }

  _createClass(InvocationResultError, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      _get(InvocationResultError.prototype.__proto__ || Object.getPrototypeOf(InvocationResultError.prototype), "serializeWireBase", this).call(this, writer);

      writer.writeVarString(this.message, MAX_SIZE);
    } // eslint-disable-next-line

  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        type: 'Error',
        message: this.message
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var reader = options.reader;

      var _get$call = _get(InvocationResultError.__proto__ || Object.getPrototypeOf(InvocationResultError), "deserializeInvocationResultWireBase", this).call(this, options),
          type = _get$call.type;

      if (type !== _InvocationResultType.INVOCATION_RESULT_TYPE.ERROR) {
        throw new _errors.InvalidFormatError();
      }

      var message = reader.readVarString(MAX_SIZE);
      return new this({
        message: message
      });
    }
  }]);

  return InvocationResultError;
}(_InvocationResultBase2.default);

exports.default = InvocationResultError;