"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _InvocationResultType = require("./InvocationResultType");

var _InvocationResultBase2 = _interopRequireDefault(require("./InvocationResultBase"));

var _errors = require("../errors");

var _contractParameter = require("../contractParameter");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InvocationResultSuccess =
/*#__PURE__*/
function (_InvocationResultBase) {
  _inherits(InvocationResultSuccess, _InvocationResultBase);

  function InvocationResultSuccess(_ref) {
    var _this;

    var stack = _ref.stack,
        stackAlt = _ref.stackAlt;

    _classCallCheck(this, InvocationResultSuccess);

    _this = _possibleConstructorReturn(this, (InvocationResultSuccess.__proto__ || Object.getPrototypeOf(InvocationResultSuccess)).call(this));
    Object.defineProperty(_this, "type", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _InvocationResultType.INVOCATION_RESULT_TYPE.SUCCESS
    });
    Object.defineProperty(_this, "stack", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "stackAlt", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.stack = stack;
    _this.stackAlt = stackAlt;
    return _this;
  }

  _createClass(InvocationResultSuccess, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      _get(InvocationResultSuccess.prototype.__proto__ || Object.getPrototypeOf(InvocationResultSuccess.prototype), "serializeWireBase", this).call(this, writer);

      writer.writeArray(this.stack, function (contractParameter) {
        return contractParameter.serializeWireBase(writer);
      });
      writer.writeArray(this.stackAlt, function (contractParameter) {
        return contractParameter.serializeWireBase(writer);
      });
    } // eslint-disable-next-line

  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        type: 'Success',
        stack: this.stack.map(function (value) {
          return value.serializeJSON(context);
        }),
        stackAlt: this.stackAlt.map(function (value) {
          return value.serializeJSON(context);
        })
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var reader = options.reader;

      var _get$call = _get(InvocationResultSuccess.__proto__ || Object.getPrototypeOf(InvocationResultSuccess), "deserializeInvocationResultWireBase", this).call(this, options),
          type = _get$call.type;

      if (type !== _InvocationResultType.INVOCATION_RESULT_TYPE.SUCCESS) {
        throw new _errors.InvalidFormatError();
      }

      var stack = reader.readArray(function () {
        return (0, _contractParameter.deserializeWireBase)(options);
      });
      var stackAlt = reader.readArray(function () {
        return (0, _contractParameter.deserializeWireBase)(options);
      });
      return new this({
        stack: stack,
        stackAlt: stackAlt
      });
    }
  }]);

  return InvocationResultSuccess;
}(_InvocationResultBase2.default);

exports.default = InvocationResultSuccess;