"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertInvocationResultType = exports.InvalidInvocationResultTypeError = exports.INVOCATION_RESULT_TYPE = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var INVOCATION_RESULT_TYPE = {
  ERROR: 0x00,
  SUCCESS: 0x01
};
exports.INVOCATION_RESULT_TYPE = INVOCATION_RESULT_TYPE;

var InvalidInvocationResultTypeError =
/*#__PURE__*/
function (_Error) {
  _inherits(InvalidInvocationResultTypeError, _Error);

  function InvalidInvocationResultTypeError(value) {
    var _this;

    _classCallCheck(this, InvalidInvocationResultTypeError);

    _this = _possibleConstructorReturn(this, (InvalidInvocationResultTypeError.__proto__ || Object.getPrototypeOf(InvalidInvocationResultTypeError)).call(this, "Expected invocation result type, found: ".concat(value.toString(16))));
    Object.defineProperty(_this, "value", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.value = value;
    return _this;
  }

  return InvalidInvocationResultTypeError;
}(Error);

exports.InvalidInvocationResultTypeError = InvalidInvocationResultTypeError;

var assertInvocationResultType = function assertInvocationResultType(value) {
  switch (value) {
    case INVOCATION_RESULT_TYPE.ERROR:
      return INVOCATION_RESULT_TYPE.ERROR;

    case INVOCATION_RESULT_TYPE.SUCCESS:
      return INVOCATION_RESULT_TYPE.SUCCESS;

    default:
      throw new InvalidInvocationResultTypeError(value);
  }
};

exports.assertInvocationResultType = assertInvocationResultType;