"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _TransactionType = require("./TransactionType");

var _TransactionBase2 = _interopRequireDefault(require("./TransactionBase"));

var _errors = require("../errors");

var _utils = _interopRequireWildcard(require("../utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

var ContractTransaction =
/*#__PURE__*/
function (_TransactionBase) {
  _inherits(ContractTransaction, _TransactionBase);

  function ContractTransaction(_ref) {
    var _this;

    var version = _ref.version,
        attributes = _ref.attributes,
        inputs = _ref.inputs,
        outputs = _ref.outputs,
        scripts = _ref.scripts,
        hash = _ref.hash;

    _classCallCheck(this, ContractTransaction);

    _this = _possibleConstructorReturn(this, (ContractTransaction.__proto__ || Object.getPrototypeOf(ContractTransaction)).call(this, {
      version: version,
      type: _TransactionType.TRANSACTION_TYPE.CONTRACT,
      attributes: attributes,
      inputs: inputs,
      outputs: outputs,
      scripts: scripts,
      hash: hash
    }));
    Object.defineProperty(_this, "__size", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });

    if (_this.version !== 0) {
      throw new _errors.InvalidFormatError();
    }

    _this.__size = _utils.default.lazy(function () {
      return _get(ContractTransaction.prototype.__proto__ || Object.getPrototypeOf(ContractTransaction.prototype), "size", _this) + _utils.IOHelper.sizeOfUInt8;
    });
    return _this;
  }

  _createClass(ContractTransaction, [{
    key: "clone",
    value: function clone(scripts) {
      return new this.constructor({
        version: this.version,
        attributes: this.attributes,
        inputs: this.inputs,
        outputs: this.outputs,
        scripts: scripts
      });
    } // eslint-disable-next-line

  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(context) {
        var transactionBaseJSON;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _get(ContractTransaction.prototype.__proto__ || Object.getPrototypeOf(ContractTransaction.prototype), "serializeTransactionBaseJSON", this).call(this, context);

              case 2:
                transactionBaseJSON = _context.sent;
                return _context.abrupt("return", {
                  type: 'ContractTransaction',
                  txid: transactionBaseJSON.txid,
                  size: transactionBaseJSON.size,
                  version: transactionBaseJSON.version,
                  attributes: transactionBaseJSON.attributes,
                  vin: transactionBaseJSON.vin,
                  vout: transactionBaseJSON.vout,
                  scripts: transactionBaseJSON.scripts,
                  sys_fee: transactionBaseJSON.sys_fee,
                  net_fee: transactionBaseJSON.net_fee
                });

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function serializeJSON(_x) {
        return _ref2.apply(this, arguments);
      }

      return serializeJSON;
    }()
  }, {
    key: "size",
    get: function get() {
      return this.__size();
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var _get$call = _get(ContractTransaction.__proto__ || Object.getPrototypeOf(ContractTransaction), "deserializeTransactionBaseStartWireBase", this).call(this, options),
          type = _get$call.type,
          version = _get$call.version;

      if (type !== _TransactionType.TRANSACTION_TYPE.CONTRACT) {
        throw new _errors.InvalidFormatError();
      }

      var _get$call2 = _get(ContractTransaction.__proto__ || Object.getPrototypeOf(ContractTransaction), "deserializeTransactionBaseEndWireBase", this).call(this, options),
          attributes = _get$call2.attributes,
          inputs = _get$call2.inputs,
          outputs = _get$call2.outputs,
          scripts = _get$call2.scripts;

      return new this({
        version: version,
        attributes: attributes,
        inputs: inputs,
        outputs: outputs,
        scripts: scripts
      });
    }
  }]);

  return ContractTransaction;
}(_TransactionBase2.default);

exports.default = ContractTransaction;