"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _TransactionType = require("./TransactionType");

var _TransactionBase2 = _interopRequireDefault(require("./TransactionBase"));

var _errors = require("../errors");

var _common = _interopRequireDefault(require("../common"));

var _crypto = _interopRequireDefault(require("../crypto"));

var _utils = _interopRequireWildcard(require("../utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

var EnrollmentTransaction =
/*#__PURE__*/
function (_TransactionBase) {
  _inherits(EnrollmentTransaction, _TransactionBase);

  function EnrollmentTransaction(_ref) {
    var _this;

    var version = _ref.version,
        attributes = _ref.attributes,
        inputs = _ref.inputs,
        outputs = _ref.outputs,
        scripts = _ref.scripts,
        hash = _ref.hash,
        publicKey = _ref.publicKey;

    _classCallCheck(this, EnrollmentTransaction);

    _this = _possibleConstructorReturn(this, (EnrollmentTransaction.__proto__ || Object.getPrototypeOf(EnrollmentTransaction)).call(this, {
      version: version,
      type: _TransactionType.TRANSACTION_TYPE.ENROLLMENT,
      attributes: attributes,
      inputs: inputs,
      outputs: outputs,
      scripts: scripts,
      hash: hash
    }));
    Object.defineProperty(_this, "publicKey", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "__size", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "__enrollmentGetScriptHashesForVerifying", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.publicKey = publicKey;

    if (_this.version !== 0) {
      throw new _errors.InvalidFormatError();
    }

    _this.__size = _utils.default.lazy(function () {
      return _get(EnrollmentTransaction.prototype.__proto__ || Object.getPrototypeOf(EnrollmentTransaction.prototype), "size", _this) + _utils.IOHelper.sizeOfUInt8 + _utils.IOHelper.sizeOfECPoint(_this.publicKey);
    });
    _this.__enrollmentGetScriptHashesForVerifying = _utils.default.lazyAsync(function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(options) {
        var hashes;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _get(EnrollmentTransaction.prototype.__proto__ || Object.getPrototypeOf(EnrollmentTransaction.prototype), "getScriptHashesForVerifying", _this).call(_this, options);

              case 2:
                hashes = _context.sent;
                return _context.abrupt("return", new Set([].concat(_toConsumableArray(hashes), [_common.default.uInt160ToHex(_crypto.default.getVerificationScriptHash(_this.publicKey))])));

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }());
    return _this;
  }

  _createClass(EnrollmentTransaction, [{
    key: "clone",
    value: function clone(scripts) {
      return new this.constructor({
        version: this.version,
        attributes: this.attributes,
        inputs: this.inputs,
        outputs: this.outputs,
        scripts: scripts,
        publicKey: this.publicKey
      });
    }
  }, {
    key: "serializeExclusiveBase",
    value: function serializeExclusiveBase(writer) {
      writer.writeECPoint(this.publicKey);
    }
  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function () {
      var _ref3 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(context) {
        var transactionBaseJSON;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _get(EnrollmentTransaction.prototype.__proto__ || Object.getPrototypeOf(EnrollmentTransaction.prototype), "serializeTransactionBaseJSON", this).call(this, context);

              case 2:
                transactionBaseJSON = _context2.sent;
                return _context2.abrupt("return", {
                  type: 'EnrollmentTransaction',
                  txid: transactionBaseJSON.txid,
                  size: transactionBaseJSON.size,
                  version: transactionBaseJSON.version,
                  attributes: transactionBaseJSON.attributes,
                  vin: transactionBaseJSON.vin,
                  vout: transactionBaseJSON.vout,
                  scripts: transactionBaseJSON.scripts,
                  sys_fee: transactionBaseJSON.sys_fee,
                  net_fee: transactionBaseJSON.net_fee,
                  pubkey: _utils.JSONHelper.writeECPoint(this.publicKey)
                });

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function serializeJSON(_x2) {
        return _ref3.apply(this, arguments);
      }

      return serializeJSON;
    }()
  }, {
    key: "getScriptHashesForVerifying",
    value: function () {
      var _ref4 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(options) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", this.__enrollmentGetScriptHashesForVerifying(options));

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getScriptHashesForVerifying(_x3) {
        return _ref4.apply(this, arguments);
      }

      return getScriptHashesForVerifying;
    }() // eslint-disable-next-line

  }, {
    key: "verify",
    value: function () {
      var _ref5 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(options) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                throw new _errors.VerifyError('Enrollment transactions are obsolete');

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function verify(_x4) {
        return _ref5.apply(this, arguments);
      }

      return verify;
    }()
  }, {
    key: "size",
    get: function get() {
      return this.__size();
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var reader = options.reader;

      var _get$call = _get(EnrollmentTransaction.__proto__ || Object.getPrototypeOf(EnrollmentTransaction), "deserializeTransactionBaseStartWireBase", this).call(this, options),
          type = _get$call.type,
          version = _get$call.version;

      if (type !== _TransactionType.TRANSACTION_TYPE.ENROLLMENT) {
        throw new _errors.InvalidFormatError();
      }

      var publicKey = reader.readECPoint();

      var _get$call2 = _get(EnrollmentTransaction.__proto__ || Object.getPrototypeOf(EnrollmentTransaction), "deserializeTransactionBaseEndWireBase", this).call(this, options),
          attributes = _get$call2.attributes,
          inputs = _get$call2.inputs,
          outputs = _get$call2.outputs,
          scripts = _get$call2.scripts;

      return new this({
        version: version,
        publicKey: publicKey,
        attributes: attributes,
        inputs: inputs,
        outputs: outputs,
        scripts: scripts
      });
    }
  }]);

  return EnrollmentTransaction;
}(_TransactionBase2.default);

exports.default = EnrollmentTransaction;