"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Serializable = require("../Serializable");

var _common = _interopRequireDefault(require("../common"));

var _utils = _interopRequireWildcard(require("../utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Input =
/*#__PURE__*/
function () {
  function Input(_ref) {
    var _this = this;

    var hash = _ref.hash,
        index = _ref.index;

    _classCallCheck(this, Input);

    Object.defineProperty(this, "hash", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "index", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "size", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.IOHelper.sizeOfUInt256 + _utils.IOHelper.sizeOfUInt16LE
    });
    Object.defineProperty(this, "equals", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.equals(Input, function (other) {
        return _common.default.uInt256Equal(_this.hash, other.hash) && other.index === _this.index;
      })
    });
    Object.defineProperty(this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this))
    });
    this.hash = hash;
    this.index = index;
  }

  _createClass(Input, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      writer.writeUInt256(this.hash);
      writer.writeUInt16LE(this.index);
    }
  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        txid: _utils.JSONHelper.writeUInt256(this.hash),
        vout: this.index
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(_ref2) {
      var reader = _ref2.reader;
      var hash = reader.readUInt256();
      var index = reader.readUInt16LE();
      return new this({
        hash: hash,
        index: index
      });
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return Input;
}();

exports.default = Input;