"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _TransactionType = require("./TransactionType");

var _TransactionBase2 = _interopRequireDefault(require("./TransactionBase"));

var _errors = require("../errors");

var _common = _interopRequireDefault(require("../common"));

var _utils = _interopRequireWildcard(require("../utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _slicedToArray(arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return _sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } } function _next(value) { step("next", value); } function _throw(err) { step("throw", err); } _next(); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

var IssueTransaction =
/*#__PURE__*/
function (_TransactionBase) {
  _inherits(IssueTransaction, _TransactionBase);

  // TODO: How is version set?
  // static VERSION = 1;
  function IssueTransaction(_ref) {
    var _this;

    var version = _ref.version,
        attributes = _ref.attributes,
        inputs = _ref.inputs,
        outputs = _ref.outputs,
        scripts = _ref.scripts,
        hash = _ref.hash;

    _classCallCheck(this, IssueTransaction);

    _this = _possibleConstructorReturn(this, (IssueTransaction.__proto__ || Object.getPrototypeOf(IssueTransaction)).call(this, {
      version: version,
      type: _TransactionType.TRANSACTION_TYPE.ISSUE,
      attributes: attributes,
      inputs: inputs,
      outputs: outputs,
      scripts: scripts,
      hash: hash
    }));
    Object.defineProperty(_this, "__size", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this, "__issueGetScriptHashesForVerifying", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });

    if (_this.version > 1) {
      throw new _errors.InvalidFormatError();
    }

    _this.__size = _utils.default.lazy(function () {
      return _get(IssueTransaction.prototype.__proto__ || Object.getPrototypeOf(IssueTransaction.prototype), "size", _this) + _utils.IOHelper.sizeOfUInt8;
    });
    _this.__issueGetScriptHashesForVerifying = _utils.default.lazyAsync(function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(options) {
        var getOutput, getAsset, _ref3, _ref4, hashes, issuerHashes;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                getOutput = options.getOutput, getAsset = options.getAsset;
                _context2.next = 3;
                return Promise.all([_get(IssueTransaction.prototype.__proto__ || Object.getPrototypeOf(IssueTransaction.prototype), "getScriptHashesForVerifying", _this).call(_this, options), _this.getTransactionResults({
                  getOutput: getOutput
                }).then(function (results) {
                  return Promise.all(_utils.default.entries(results) // eslint-disable-next-line
                  .filter(function (_ref5) {
                    var _ref6 = _slicedToArray(_ref5, 2),
                        _ = _ref6[0],
                        value = _ref6[1];

                    return value.lt(_utils.default.ZERO);
                  }) // eslint-disable-next-line
                  .map(function () {
                    var _ref8 = _asyncToGenerator(
                    /*#__PURE__*/
                    regeneratorRuntime.mark(function _callee(_ref7) {
                      var _ref9, hash, _, asset;

                      return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                          switch (_context.prev = _context.next) {
                            case 0:
                              _ref9 = _slicedToArray(_ref7, 2), hash = _ref9[0], _ = _ref9[1];
                              _context.next = 3;
                              return getAsset({
                                hash: _common.default.hexToUInt256(hash)
                              });

                            case 3:
                              asset = _context.sent;
                              return _context.abrupt("return", _common.default.uInt160ToHex(asset.issuer));

                            case 5:
                            case "end":
                              return _context.stop();
                          }
                        }
                      }, _callee, this);
                    }));

                    return function (_x2) {
                      return _ref8.apply(this, arguments);
                    };
                  }()));
                })]);

              case 3:
                _ref3 = _context2.sent;
                _ref4 = _slicedToArray(_ref3, 2);
                hashes = _ref4[0];
                issuerHashes = _ref4[1];
                return _context2.abrupt("return", new Set([].concat(_toConsumableArray(hashes), _toConsumableArray(issuerHashes))));

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }());
    return _this;
  }

  _createClass(IssueTransaction, [{
    key: "clone",
    value: function clone(scripts) {
      return new this.constructor({
        version: this.version,
        attributes: this.attributes,
        inputs: this.inputs,
        outputs: this.outputs,
        scripts: scripts
      });
    } // eslint-disable-next-line

  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function () {
      var _ref10 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee3(context) {
        var transactionBaseJSON;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return _get(IssueTransaction.prototype.__proto__ || Object.getPrototypeOf(IssueTransaction.prototype), "serializeTransactionBaseJSON", this).call(this, context);

              case 2:
                transactionBaseJSON = _context3.sent;
                return _context3.abrupt("return", {
                  type: 'IssueTransaction',
                  txid: transactionBaseJSON.txid,
                  size: transactionBaseJSON.size,
                  version: transactionBaseJSON.version,
                  attributes: transactionBaseJSON.attributes,
                  vin: transactionBaseJSON.vin,
                  vout: transactionBaseJSON.vout,
                  scripts: transactionBaseJSON.scripts,
                  sys_fee: transactionBaseJSON.sys_fee,
                  net_fee: transactionBaseJSON.net_fee
                });

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function serializeJSON(_x3) {
        return _ref10.apply(this, arguments);
      }

      return serializeJSON;
    }()
  }, {
    key: "getSystemFee",
    value: function getSystemFee(context) {
      if (this.version >= 1) {
        return _utils.default.ZERO;
      }

      var governingToken = context.governingToken,
          utilityToken = context.utilityToken;

      if (this.outputs.every(function (output) {
        return _common.default.uInt256Equal(output.asset, governingToken.hash) || _common.default.uInt256Equal(output.asset, utilityToken.hash);
      })) {
        return _utils.default.ZERO;
      }

      return _get(IssueTransaction.prototype.__proto__ || Object.getPrototypeOf(IssueTransaction.prototype), "getSystemFee", this).call(this, context);
    }
  }, {
    key: "getScriptHashesForVerifying",
    value: function () {
      var _ref11 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee4(options) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt("return", this.__issueGetScriptHashesForVerifying(options));

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getScriptHashesForVerifying(_x4) {
        return _ref11.apply(this, arguments);
      }

      return getScriptHashesForVerifying;
    }()
  }, {
    key: "verify",
    value: function () {
      var _ref12 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee5(options) {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return Promise.all([_get(IssueTransaction.prototype.__proto__ || Object.getPrototypeOf(IssueTransaction.prototype), "verify", this).call(this, options), this._verify(options)]);

              case 2:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function verify(_x5) {
        return _ref12.apply(this, arguments);
      }

      return verify;
    }()
  }, {
    key: "_verify",
    value: function () {
      var _ref13 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee7(options) {
        var _this2 = this;

        var getOutput, getAsset, _options$memPool, memPool, results;

        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                getOutput = options.getOutput, getAsset = options.getAsset, _options$memPool = options.memPool, memPool = _options$memPool === void 0 ? [] : _options$memPool;
                _context7.next = 3;
                return this.getTransactionResults({
                  getOutput: getOutput
                });

              case 3:
                results = _context7.sent;
                _context7.next = 6;
                return Promise.all(_utils.default.entries(results).map(function () {
                  var _ref15 = _asyncToGenerator(
                  /*#__PURE__*/
                  regeneratorRuntime.mark(function _callee6(_ref14) {
                    var _ref16, assetHex, value, hash, asset, issued;

                    return regeneratorRuntime.wrap(function _callee6$(_context6) {
                      while (1) {
                        switch (_context6.prev = _context6.next) {
                          case 0:
                            _ref16 = _slicedToArray(_ref14, 2), assetHex = _ref16[0], value = _ref16[1];
                            hash = _common.default.hexToUInt256(assetHex);
                            _context6.next = 4;
                            return getAsset({
                              hash: hash
                            });

                          case 4:
                            asset = _context6.sent;

                            if (!asset.amount.lt(_utils.default.ZERO)) {
                              _context6.next = 7;
                              break;
                            }

                            return _context6.abrupt("return");

                          case 7:
                            issued = asset.available.add(memPool.filter(function (transaction) {
                              return transaction !== _this2;
                            }).reduce(function (acc, transaction) {
                              return transaction.outputs.filter(function (output) {
                                return _common.default.uInt256Equal(hash, output.asset);
                              }).reduce(function (innerAcc, output) {
                                return innerAcc.add(output.value);
                              }, acc);
                            }, _utils.default.ZERO));

                            if (!asset.amount.sub(issued).lt(value.neg())) {
                              _context6.next = 10;
                              break;
                            }

                            throw new _errors.VerifyError('Invalid issue amount');

                          case 10:
                          case "end":
                            return _context6.stop();
                        }
                      }
                    }, _callee6, this);
                  }));

                  return function (_x7) {
                    return _ref15.apply(this, arguments);
                  };
                }()));

              case 6:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function _verify(_x6) {
        return _ref13.apply(this, arguments);
      }

      return _verify;
    }()
  }, {
    key: "size",
    get: function get() {
      return this.__size();
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var _get$call = _get(IssueTransaction.__proto__ || Object.getPrototypeOf(IssueTransaction), "deserializeTransactionBaseStartWireBase", this).call(this, options),
          type = _get$call.type,
          version = _get$call.version;

      if (type !== _TransactionType.TRANSACTION_TYPE.ISSUE) {
        throw new _errors.InvalidFormatError();
      }

      var _get$call2 = _get(IssueTransaction.__proto__ || Object.getPrototypeOf(IssueTransaction), "deserializeTransactionBaseEndWireBase", this).call(this, options),
          attributes = _get$call2.attributes,
          inputs = _get$call2.inputs,
          outputs = _get$call2.outputs,
          scripts = _get$call2.scripts;

      return new this({
        version: version,
        attributes: attributes,
        inputs: inputs,
        outputs: outputs,
        scripts: scripts
      });
    }
  }]);

  return IssueTransaction;
}(_TransactionBase2.default);

exports.default = IssueTransaction;