"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Serializable = require("../Serializable");

var _common = _interopRequireDefault(require("../common"));

var _crypto = _interopRequireDefault(require("../crypto"));

var _utils = _interopRequireWildcard(require("../utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Output =
/*#__PURE__*/
function () {
  function Output(_ref) {
    var _this = this;

    var asset = _ref.asset,
        value = _ref.value,
        address = _ref.address;

    _classCallCheck(this, Output);

    Object.defineProperty(this, "asset", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "value", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "address", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "size", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.IOHelper.sizeOfUInt256 + _utils.IOHelper.sizeOfUInt16LE + _utils.IOHelper.sizeOfUInt160
    });
    Object.defineProperty(this, "equals", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.equals(Output, function (other) {
        return _common.default.uInt256Equal(_this.asset, other.asset) && _this.value.eq(other.value) && _common.default.uInt160Equal(_this.address, other.address);
      })
    });
    Object.defineProperty(this, "serializeWire", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: (0, _Serializable.createSerializeWire)(this.serializeWireBase.bind(this))
    });
    this.asset = asset;
    this.value = value;
    this.address = address;
  }

  _createClass(Output, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      writer.writeUInt256(this.asset);
      writer.writeFixed8(this.value);
      writer.writeUInt160(this.address);
    }
  }, {
    key: "serializeJSON",
    // TODO: Maybe store index on Output directly? And add it when deserializing
    //       from transaction
    // eslint-disable-next-line
    value: function serializeJSON(context, index) {
      return {
        n: index,
        asset: _utils.JSONHelper.writeUInt256(this.asset),
        value: _utils.JSONHelper.writeFixed8(this.value),
        address: _crypto.default.scriptHashToAddress({
          addressVersion: context.addressVersion,
          scriptHash: this.address
        })
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(_ref2) {
      var reader = _ref2.reader;
      var asset = reader.readUInt256();
      var value = reader.readFixed8();
      var address = reader.readUInt160();
      return new this({
        asset: asset,
        value: value,
        address: address
      });
    }
  }, {
    key: "deserializeWire",
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _utils.BinaryReader(options.buffer)
      });
    }
  }]);

  return Output;
}();

exports.default = Output;