"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertTransactionType = exports.InvalidTransactionTypeError = exports.TRANSACTION_TYPE = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TRANSACTION_TYPE = {
  MINER: 0x00,
  ISSUE: 0x01,
  CLAIM: 0x02,
  ENROLLMENT: 0x20,
  REGISTER: 0x40,
  CONTRACT: 0x80,
  PUBLISH: 0xd0,
  INVOCATION: 0xd1
};
exports.TRANSACTION_TYPE = TRANSACTION_TYPE;

var InvalidTransactionTypeError =
/*#__PURE__*/
function (_Error) {
  _inherits(InvalidTransactionTypeError, _Error);

  function InvalidTransactionTypeError(transactionType) {
    var _this;

    _classCallCheck(this, InvalidTransactionTypeError);

    _this = _possibleConstructorReturn(this, (InvalidTransactionTypeError.__proto__ || Object.getPrototypeOf(InvalidTransactionTypeError)).call(this, "Expected transaction type, found: ".concat(transactionType.toString(16))));
    Object.defineProperty(_this, "transactionType", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    _this.transactionType = transactionType;
    return _this;
  }

  return InvalidTransactionTypeError;
}(Error);

exports.InvalidTransactionTypeError = InvalidTransactionTypeError;

var assertTransactionType = function assertTransactionType(value) {
  switch (value) {
    case 0x00:
      // Miner
      return 0x00;

    case 0x01:
      // Issue
      return 0x01;

    case 0x02:
      // Claim
      return 0x02;

    case 0x20:
      // Enrollment
      return 0x20;

    case 0x40:
      // Register
      return 0x40;

    case 0x80:
      // Contract
      return 0x80;

    case 0xd0:
      // Publish
      return 0xd0;

    case 0xd1:
      // Invocation
      return 0xd1;

    default:
      throw new InvalidTransactionTypeError(value);
  }
};

exports.assertTransactionType = assertTransactionType;