"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _AttributeBase2 = _interopRequireDefault(require("./AttributeBase"));

var _errors = require("../../errors");

var _AttributeUsage = require("./AttributeUsage");

var _common = _interopRequireDefault(require("../../common"));

var _utils = _interopRequireWildcard(require("../../utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return _get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ECPointAttribute =
/*#__PURE__*/
function (_AttributeBase) {
  _inherits(ECPointAttribute, _AttributeBase);

  function ECPointAttribute(_ref) {
    var _this;

    var usage = _ref.usage,
        value = _ref.value;

    _classCallCheck(this, ECPointAttribute);

    _this = _possibleConstructorReturn(this, (ECPointAttribute.__proto__ || Object.getPrototypeOf(ECPointAttribute)).call(this));
    Object.defineProperty(_this, "equals", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _utils.default.equals(ECPointAttribute, function (other) {
        return _this.usage === other.usage && _common.default.ecPointEqual(_this.value, other.value);
      })
    });
    _this.usage = usage;
    _this.value = value;
    _this.size = _utils.IOHelper.sizeOfUInt8 + _utils.IOHelper.sizeOfECPoint(_this.value);
    return _this;
  }

  _createClass(ECPointAttribute, [{
    key: "serializeWireBase",
    value: function serializeWireBase(writer) {
      _get(ECPointAttribute.prototype.__proto__ || Object.getPrototypeOf(ECPointAttribute.prototype), "serializeWireBase", this).call(this, writer);

      writer.writeBytes(_common.default.ecPointToBuffer(this.value).slice(1));
    } // eslint-disable-next-line

  }, {
    key: "serializeJSON",
    // eslint-disable-next-line
    value: function serializeJSON(context) {
      return {
        usage: (0, _AttributeUsage.toJSONAttributeUsage)(this.usage),
        data: _utils.JSONHelper.writeECPoint(this.value)
      };
    }
  }], [{
    key: "deserializeWireBase",
    value: function deserializeWireBase(options) {
      var reader = options.reader;

      var _get$call = _get(ECPointAttribute.__proto__ || Object.getPrototypeOf(ECPointAttribute), "deserializeAttributeWireBase", this).call(this, options),
          usage = _get$call.usage;

      if (!(usage === 0x02 || usage === 0x03)) {
        throw new _errors.InvalidFormatError();
      }

      var value = _common.default.bufferToECPoint(Buffer.concat([Buffer.from([usage]), reader.readBytes(32)]));

      return new this({
        usage: usage,
        value: value
      });
    }
  }]);

  return ECPointAttribute;
}(_AttributeBase2.default);

exports.default = ECPointAttribute;