"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _bn = _interopRequireDefault(require("bn.js"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _common = _interopRequireDefault(require("../common"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  writeUInt64LE: function writeUInt64LE(value) {
    return value.toString(16, 16);
  },
  readUInt64LE: function readUInt64LE(value) {
    return new _bn.default(value, 16);
  },
  writeUInt160: function writeUInt160(value) {
    return _common.default.uInt160ToString(value);
  },
  readUInt160: function readUInt160(hash) {
    return _common.default.stringToUInt160(hash);
  },
  writeUInt256: function writeUInt256(value) {
    return _common.default.uInt256ToString(value);
  },
  readUInt256: function readUInt256(hash) {
    return _common.default.stringToUInt256(hash);
  },
  writeFixed8: function writeFixed8(value) {
    return _common.default.fixed8ToDecimal(value).toString();
  },
  readFixed8: function readFixed8(value) {
    return _common.default.fixed8FromDecimal(new _bignumber.default(value));
  },
  writeECPoint: function writeECPoint(value) {
    return _common.default.ecPointToString(value);
  },
  readECPoint: function readECPoint(value) {
    return _common.default.stringToECPoint(value);
  },
  writeBuffer: function writeBuffer(value) {
    return value.toString('hex');
  },
  readBuffer: function readBuffer(value) {
    return Buffer.from(value, 'hex');
  }
};
exports.default = _default;