"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _async = _interopRequireDefault(require("async"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO: Should just eliminate this to keep package size down
var promisify = function promisify(func) {
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new Promise(function (resolve, reject) {
      return func.apply(void 0, args.concat([function (error, result) {
        if (error != null) {
          reject(error);
        } else {
          resolve(result);
        }
      }]));
    });
  };
};

var promisifiedSome = promisify(_async.default.some);

function some(values, func) {
  return promisifiedSome(values, _async.default.asyncify(func));
}

var _default = {
  some: some
};
exports.default = _default;