"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = weightedFilter;

function weightedFilter(input, start, end, getValue) {
  var amount = input.reduce(function (acc, value) {
    return acc + getValue(value);
  }, 0);
  var sum = 0;
  var current = 0;
  var result = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = input[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _value2 = _step.value;

      if (current >= end) {
        break;
      }

      var weight = getValue(_value2);
      sum += weight;
      var old = current;
      current = sum / amount;

      if (current <= start) {
        // eslint-disable-next-line
        continue;
      }

      if (old < start) {
        if (current > end) {
          weight = (end - start) * amount;
        } else {
          weight = (current - start) * amount;
        }
      } else if (current > end) {
        weight = (end - old) * amount;
      }

      result.push([_value2, weight >= 0 ? Math.floor(weight) : Math.ceil(weight)]);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return result;
}